=== modified file 'TODO'
--- TODO	2008-11-09 06:40:29 +0000
+++ TODO	2008-10-28 18:00:20 +0000
@@ -14,18 +14,6 @@
 ** TODO [#B] Run-time communication with server :bugs:
    Probably using D-Bus
    See also [[*Mandos-tools]]
-*** Client class
-    + getHostname
-    + getChecker
-    + setChecker
-*** Main server
-    + Clients
-      out_signature="ao"
-      Does this have to be "getClients" so as not to collide with the
-      interface name?
-    + setLogLevel
-      syslogger.setLevel(logging.WARNING)
-    + quit
 ** TODO Implement --foreground			:bugs:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket

=== modified file 'mandos'
--- mandos	2008-11-09 06:40:29 +0000
+++ mandos	2008-10-17 18:56:25 +0000
@@ -30,7 +30,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, with_statement, absolute_import
+from __future__ import division
 
 import SocketServer
 import socket
@@ -55,10 +55,8 @@
 import logging
 import logging.handlers
 import pwd
-from contextlib import closing
 
 import dbus
-import dbus.service
 import gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
@@ -172,7 +170,7 @@
 # End of Avahi example code
 
 
-class Client(dbus.service.Object):
+class Client(object):
     """A representation of a client host served by this server.
     Attributes:
     name:      string; from the config file, used in log messages
@@ -181,7 +179,6 @@
     secret:    bytestring; sent verbatim (over TLS) to client
     host:      string; available for use by the checker command
     created:   datetime.datetime(); object creation, not client host
-    started:   bool()
     last_checked_ok: datetime.datetime() or None if not yet checked OK
     timeout:   datetime.timedelta(); How long from last_checked_ok
                                      until this client is invalid
@@ -203,49 +200,19 @@
     _timeout_milliseconds: Used when calling gobject.timeout_add()
     _interval_milliseconds: - '' -
     """
-    interface = u"org.mandos_system.Mandos.Clients"
-    
-    @dbus.service.method(interface, out_signature="s")
-    def getName(self):
-        "D-Bus getter method"
-        return self.name
-    
-    @dbus.service.method(interface, out_signature="s")
-    def getFingerprint(self):
-        "D-Bus getter method"
-        return self.fingerprint
-    
-    @dbus.service.method(interface, in_signature="ay",
-                         byte_arrays=True)
-    def setSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = secret
-    
     def _set_timeout(self, timeout):
-        "Setter function for the 'timeout' attribute"
+        "Setter function for 'timeout' attribute"
         self._timeout = timeout
         self._timeout_milliseconds = ((self.timeout.days
                                        * 24 * 60 * 60 * 1000)
                                       + (self.timeout.seconds * 1000)
                                       + (self.timeout.microseconds
                                          // 1000))
-        # Emit D-Bus signal
-        self.TimeoutChanged(self._timeout_milliseconds)
-    timeout = property(lambda self: self._timeout, _set_timeout)
+    timeout = property(lambda self: self._timeout,
+                       _set_timeout)
     del _set_timeout
-    
-    @dbus.service.method(interface, out_signature="t")
-    def getTimeout(self):
-        "D-Bus getter method"
-        return self._timeout_milliseconds
-    
-    @dbus.service.signal(interface, signature="t")
-    def TimeoutChanged(self, t):
-        "D-Bus signal"
-        pass
-    
     def _set_interval(self, interval):
-        "Setter function for the 'interval' attribute"
+        "Setter function for 'interval' attribute"
         self._interval = interval
         self._interval_milliseconds = ((self.interval.days
                                         * 24 * 60 * 60 * 1000)
@@ -253,28 +220,13 @@
                                           * 1000)
                                        + (self.interval.microseconds
                                           // 1000))
-        # Emit D-Bus signal
-        self.IntervalChanged(self._interval_milliseconds)
-    interval = property(lambda self: self._interval, _set_interval)
+    interval = property(lambda self: self._interval,
+                        _set_interval)
     del _set_interval
-    
-    @dbus.service.method(interface, out_signature="t")
-    def getInterval(self):
-        "D-Bus getter method"
-        return self._interval_milliseconds
-    
-    @dbus.service.signal(interface, signature="t")
-    def IntervalChanged(self, t):
-        "D-Bus signal"
-        pass
-    
     def __init__(self, name = None, stop_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
-        dbus.service.Object.__init__(self, bus,
-                                     "/Mandos/Clients/%s"
-                                     % name.replace(".", "_"))
         if config is None:
             config = {}
         self.name = name
@@ -288,17 +240,15 @@
         if "secret" in config:
             self.secret = config["secret"].decode(u"base64")
         elif "secfile" in config:
-            with closing(open(os.path.expanduser
-                              (os.path.expandvars
-                               (config["secfile"])))) \
-                               as secfile:
-                self.secret = secfile.read()
+            secfile = open(os.path.expanduser(os.path.expandvars
+                                              (config["secfile"])))
+            self.secret = secfile.read()
+            secfile.close()
         else:
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.now()
-        self.started = False
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
         self.interval = string_to_delta(config["interval"])
@@ -308,10 +258,8 @@
         self.stop_initiator_tag = None
         self.checker_callback_tag = None
         self.check_command = config["checker"]
-    
     def start(self):
         """Start this client's checker and timeout hooks"""
-        self.started = True
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
         self.checker_initiator_tag = gobject.timeout_add\
@@ -323,18 +271,14 @@
         self.stop_initiator_tag = gobject.timeout_add\
                                   (self._timeout_milliseconds,
                                    self.stop)
-        # Emit D-Bus signal
-        self.StateChanged(True)
-    
-    @dbus.service.signal(interface, signature="b")
-    def StateChanged(self, started):
-        "D-Bus signal"
-        pass
-    
     def stop(self):
-        """Stop this client."""
-        if getattr(self, "started", False):
+        """Stop this client.
+        The possibility that a client might be restarted is left open,
+        but not currently used."""
+        # If this client doesn't have a secret, it is already stopped.
+        if hasattr(self, "secret") and self.secret:
             logger.info(u"Stopping client %s", self.name)
+            self.secret = None
         else:
             return False
         if getattr(self, "stop_initiator_tag", False):
@@ -346,56 +290,31 @@
         self.stop_checker()
         if self.stop_hook:
             self.stop_hook(self)
-        # Emit D-Bus signal
-        self.StateChanged(False)
         # Do not run this again if called by a gobject.timeout_add
         return False
-    # D-Bus variant
-    Stop = dbus.service.method(interface)(stop)
-    
     def __del__(self):
         self.stop_hook = None
         self.stop()
-    
     def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
+        now = datetime.datetime.now()
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition) \
                and (os.WEXITSTATUS(condition) == 0):
             logger.info(u"Checker for %(name)s succeeded",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(True)
-            self.bump_timeout()
+            self.last_checked_ok = now
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = gobject.timeout_add\
+                                      (self._timeout_milliseconds,
+                                       self.stop)
         elif not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
         else:
             logger.info(u"Checker for %(name)s failed",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
-    
-    @dbus.service.signal(interface, signature="b")
-    def CheckerCompleted(self, success):
-        "D-Bus signal"
-        pass
-    
-    def bump_timeout(self):
-        """Bump up the timeout for this client.
-        This should only be called when the client has been seen,
-        alive and well.
-        """
-        self.last_checked_ok = datetime.datetime.now()
-        gobject.source_remove(self.stop_initiator_tag)
-        self.stop_initiator_tag = gobject.timeout_add\
-            (self._timeout_milliseconds, self.stop)
-    # D-Bus variant
-    bumpTimeout = dbus.service.method(interface)(bump_timeout)
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
@@ -436,23 +355,11 @@
                 self.checker_callback_tag = gobject.child_watch_add\
                                             (self.checker.pid,
                                              self.checker_callback)
-                # Emit D-Bus signal
-                self.CheckerStarted(command)
             except OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
-    
-    @dbus.service.signal(interface, signature="s")
-    def CheckerStarted(self, command):
-        pass
-    
-    @dbus.service.method(interface, out_signature="b")
-    def checkerIsRunning(self):
-        "D-Bus getter method"
-        return self.checker is not None
-    
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
         if self.checker_callback_tag:
@@ -470,23 +377,13 @@
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
-    # D-Bus variant
-    StopChecker = dbus.service.method(interface)(stop_checker)
-    
     def still_valid(self):
         """Has the timeout not yet passed for this client?"""
-        if not self.started:
-            return False
         now = datetime.datetime.now()
         if self.last_checked_ok is None:
             return now < (self.created + self.timeout)
         else:
             return now < (self.last_checked_ok + self.timeout)
-    # D-Bus variant
-    stillValid = dbus.service.method(interface, out_signature="b")\
-        (still_valid)
-    
-    del interface
 
 
 def peer_certificate(session):
@@ -550,7 +447,7 @@
     
     def handle(self):
         logger.info(u"TCP connection from: %s",
-                    unicode(self.client_address))
+                     unicode(self.client_address))
         session = gnutls.connection.ClientSession\
                   (self.request, gnutls.connection.X509Credentials())
         
@@ -571,8 +468,10 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        # Use a fallback default, since this MUST be set.
-        priority = self.server.settings.get("priority", "NORMAL")
+        priority = "NORMAL"             # Fallback default, since this
+                                        # MUST be set.
+        if self.server.settings["priority"]:
+            priority = self.server.settings["priority"]
         gnutls.library.functions.gnutls_priority_set_direct\
             (session._c_object, priority, None)
         
@@ -608,8 +507,6 @@
                            vars(client))
             session.bye()
             return
-        ## This won't work here, since we're in a fork.
-        # client.bump_timeout()
         sent_size = 0
         while sent_size < len(client.secret):
             sent = session.send(client.secret[sent_size:])
@@ -620,8 +517,7 @@
         session.bye()
 
 
-class IPv6_TCPServer(SocketServer.ForkingMixIn,
-                     SocketServer.TCPServer, object):
+class IPv6_TCPServer(SocketServer.ForkingTCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
         settings:       Server settings
@@ -756,9 +652,10 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack("16s16x", interface))
+            s = socket.socket()
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack("16s16x", interface))
+            s.close()
             interface_index = struct.unpack("I", ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)

